import { InfiniteScrollState, ScrollDirection, ScrollingContainerRef, ScrollOffsetValues, InfiniteScrollProps, UseInfiniteScrollProps, ScrollPosition, ScrollAxisName, ElementRef } from './types';
declare class InfiniteScroll {
    props: InfiniteScrollProps;
    state: InfiniteScrollState;
    _scrollingContainerRef?: ScrollingContainerRef;
    constructor(props: InfiniteScrollProps);
    _validateScrollValue: (scrollPosition: number, scrollSize: number, fallbackValue?: number) => number;
    _scroll: (this: InfiniteScroll, { scrollTop, scrollLeft }: ScrollPosition) => void;
    _computeThreshold: (this: InfiniteScroll) => void;
    _getPossibleDirections: (this: InfiniteScroll, offset?: number) => Required<ScrollOffsetValues>;
    _loadByDirection: (this: InfiniteScroll, direction1: ScrollDirection.UP | ScrollDirection.LEFT, direction2: ScrollDirection.DOWN | ScrollDirection.RIGHT, offset: Required<ScrollOffsetValues>) => Promise<void>;
    _checkOffsetAndLoadMore: (this: InfiniteScroll) => void;
    _setRef: (this: InfiniteScroll, ref: ElementRef | null) => void;
    _resetThreshold: (this: InfiniteScroll, direction: ScrollDirection, offset?: number, hardReset?: boolean) => void;
    _onLoadComplete: (this: InfiniteScroll, axis: ScrollAxisName) => void;
    _onPropsChange: (this: InfiniteScroll, props: UseInfiniteScrollProps) => void;
    _onCleanup: (this: InfiniteScroll) => void;
    setRef: (ref: ElementRef | null) => void;
    onPropsChange: (props: UseInfiniteScrollProps) => void;
    onCleanup: () => void;
}
export default InfiniteScroll;
